//+------------------------------------------------------------------+
//|                             Williams_ROC_Rainbow_TF_selec.mq4    |
//|                                        Copyright  2010, Brooky. |
//|                                                                  |
//| Indicator  to assist CycleSurfer Trading System Concept          |
//|http://www.forex-tsd.com/suggestions-trading-systems              |
//                    25090-my-new-day-trading-system-rate-test.html |
//|Thanks to mladenfx & Jose Silva for Rainbow concept.              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Brooky."
#property link      "http://www.NoLinkYet.com"
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 C'151,15,43'
#property indicator_color2 C'33,12,135'
#property indicator_color3 C'151,15,43'
#property indicator_color4 C'33,12,135'
#property indicator_color5 C'94,124,31'
#property indicator_color6 Crimson

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3

#property indicator_levelwidth 1
#property indicator_levelstyle 0

#property indicator_level1 0.618
#property indicator_level2 0.382
#property indicator_level3 0

#property indicator_level4 -0.382
#property indicator_level5 -0.618
#property indicator_level6 -1
#property indicator_level7 1

#property indicator_maximum 2
#property indicator_minimum -2

extern int       Bars_Back=5000;//Limit Bars back to speed processing
extern int       Display_Tf = 0;
/* -- Uncomment for testing only. Need to comment further down.
extern   int       Price_Array_ma_period=13; //Price Array smoothing Period
extern   int       start_bars_back=26; //Base point to start rate of change from   
extern   double       Price_Multiplier=100;//Increases Visual Price Movement 1000 for M1//100 for H1 approx

extern   int          wperiod = 133;//=133;//Williams % Period Default 2000
extern   int       WPI_Array_ma_period = 200;//=200;//WPI Array smoothing Period 
*/
double ArrayOnWill[];
double ArrayOnPriceAction[];
double RawWillArray[];
double PriceUp[];
double PriceDn[];
double WPRup[];
double WPRdn[];
double RawPriceMa[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(8);

   SetIndexBuffer(0,ArrayOnWill);SetIndexStyle(0,DRAW_LINE) ;
     
   SetIndexBuffer(1,ArrayOnPriceAction);SetIndexStyle(1,DRAW_LINE);
   
   SetIndexBuffer(2,PriceUp);SetIndexStyle(2,DRAW_HISTOGRAM);

   SetIndexBuffer(3,PriceDn);SetIndexStyle(3,DRAW_HISTOGRAM);
      
   SetIndexBuffer(4,WPRup);SetIndexStyle(4,DRAW_HISTOGRAM);

   SetIndexBuffer(5,WPRdn);SetIndexStyle(5,DRAW_HISTOGRAM);

   //---- name 
   IndicatorShortName("Williams_ROC_Rainbow");
   SetIndexLabel(0,"Williams_ROC_Rainbow");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
           

 return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;

//-------Declare Arrays--------+   
   ArrayResize(RawWillArray, Bars_Back);   
   ArraySetAsSeries(RawWillArray, true);
   
   ArrayResize(RawPriceMa, Bars_Back);   
   ArraySetAsSeries(RawPriceMa, true);
//-------Declare Variables--------+   
//Comment out if testing settings from HERE 
   int       Price_Array_ma_period=13; //Price Array smoothing Period
   int       start_bars_back=26; //Base point to start rate of change from   
   double    Price_Multiplier=100;//Increases Visual Price Movement 1000 for M1//100 for H1 approx
   int       wperiod =133;//Williams % Period Default 2000
   int       WPI_Array_ma_period;//=200;//WPI Array smoothing Period
//--TO HERE


//--------Need to dull signal for M1 only. Too powerful.

   for(int i = Bars_Back-1; i >= 0; i--)
   {
       if(Period()==1)
       {
       wperiod=2000;//Williams % Period Default 2000
       WPI_Array_ma_period=2000;//WPI Array smoothing Period
       Price_Multiplier=100;
       } 
       if( iClose(NULL,0,i)>10)
       {
       Price_Multiplier=1;
       }

 }  
 
//-------Loop for wpr---------+  
   for(i = Bars_Back-1; i >= 0; i--)
   { 
   
        int up = 0;
        int dn = 0;
        double ROCadjust;
        
        double ROC =iWPR(NULL,Display_Tf,wperiod,i) - iWPR(NULL,Display_Tf,wperiod,i+start_bars_back);
        
          if(ROC>0)
           {
           WPRup[i]=( MathExp( ROC ) - 1 ) / ( MathExp( ROC ) + 1 );
           ROCadjust=WPRup[i];
           }
        if(ROC<0)
           {
           WPRdn[i] =( MathExp( ROC ) - 1 ) / ( MathExp( ROC ) + 1 );
           ROCadjust=WPRdn[i];
           }
        RawWillArray[i]=ROCadjust;
      }  
        
        //----------Price Action Rate of Change
           for(i = Bars_Back-1; i >= 0; i--)
       {
       double ROC_Cadjust;
       double ROC_C = (iClose(NULL,Display_Tf,i) - iClose(NULL,Display_Tf,i+start_bars_back));
           if(ROC_C>0)
           {
           PriceUp[i]=( MathExp( ROC_C ) - 1 ) / ( MathExp( ROC_C ) + 1 );
           ROC_Cadjust=PriceUp[i];
           
           }
        if(ROC_C<0)
           {
           PriceDn[i]=( MathExp( ROC_C ) - 1 ) / ( MathExp( ROC_C ) + 1 );
           ROC_Cadjust=PriceDn[i];
           }
          RawPriceMa[i]=iClose(NULL,Display_Tf,i)  -(iClose(NULL,Display_Tf,i)*(ROC_Cadjust*(Price_Multiplier/100)));
           }
   

   for( i = Bars_Back-1-wperiod; i >= 0; i--)  
   {    
    ArrayOnWill[i] = (iHigh(NULL,Display_Tf,i)+iLow(NULL,Display_Tf,i))/2  -((iHigh(NULL,Display_Tf,i)+iLow(NULL,Display_Tf,i))/2*(iMAOnArray(RawWillArray, Display_Tf,WPI_Array_ma_period, 0, 0, i))/1000);
    PriceUp[i]=ArrayOnWill[i];
     
    ArrayOnPriceAction[i] = iMAOnArray(RawPriceMa, 0,Price_Array_ma_period, 0, 0, i);
    PriceDn[i]= ArrayOnPriceAction[i];
    
    WPRup[i]= iMA(NULL,Display_Tf,Price_Array_ma_period,0,MODE_LWMA,PRICE_CLOSE,i);
    WPRdn[i]= iMA(NULL,Display_Tf,start_bars_back,0,MODE_LWMA,PRICE_CLOSE,i);


   }
  
 
   return(0);
  }//----------------------------------------------+